using System;
module Program
{
  public static mutable f : void -> string; // függvény típusú változó
  static Save(g: void -> string) : void // függvényparaméter
  { 
     f=g; 
  }
  static Call(h: string -> void) : void
  {
     h(f());
  }
  static Probe() : void
  {
	 if (false)
    {
		def f() { "hello"; };
		Save(f);
    }
    else
    {
		def f() { "bello"; };
		Save(f);
    }
	Call(System.Console.WriteLine);
  }

  static fakt(i: int) : int
  {
	 if ( i == 1)
	 {
		1
	 }
	 else
	 {
		i*fakt(i-1); // rekurzív fvhívás
	 }
  }

  static fib (n : int) : int
	{
	   def my_loop (last1 : int, last2 : int, cur : int) : int {
		 if (cur >= n)
		   last2
		 else
		   my_loop (last2, last1 + last2, cur + 1) // úgynevezett tail call -> nincs új stack frame
	   }
	 
	   my_loop (1, 1, 1) 
	}

  static Main() : int
  {
  
    def swap(x,y) { (y,x); };  // tuple típus, és lokális függvény, típuskövetkeztetéssel
    mutable x=5, y=6;
    (x,y)=swap(x,y);
    
    def osztas(x : int, y : int) : int * int { (x/y, x%y); } // tuple, lokális függvény, explicit típusokkal
    mutable a : int = 12;
    mutable b : int = 5;
    (a,b)=osztas(a,b);

	def c=1;
	match(c)  // "case" szerkezet
	{
		| 1 => System.Console.WriteLine("1");
		| _ => System.Console.WriteLine("mégse");
	}

	match (swap(x,y)) // "case" szerkezet, tuple típussal
	{
		| (5,6) => System.Console.WriteLine("swap");
		| (5,_) => System.Console.WriteLine("hello");
		| (_,6) => ();
		| (_,_) => a=5;
	}
	(); // üres kifejezés, mint utasítás (típusa void, értéke "()" (a void típus egyetlen értéke) );
	def f1() 
	{ 
		def f2() 
		{
			"nested"
		}
		System.Console.WriteLine(f2()) // egymásba ágyazott lokális függvények
	}
	f1();

	def f1(x : int, y : int) : int
	{
		x+y;
	}
	def f1(x : string, y : string) : int
	{
		Convert.ToInt32(x)+Convert.ToInt32(y);
	}
	def f1(x : int, y : int) : int
	{
		x*y;
	}
	System.Console.WriteLine(f1(1,2)); // azonos nevű, de különböző szignatúrájú lokális fv-ek elfedik egymást
 
    mutable l = 0;
	l = if (a==5) 5 else 6; // az if szerekezet is kifejezés :)

	def Execute(a, b, f) { f(a,b); };
	def k=Execute(5,6, fun (x,y) { x + y }); // anoním függvény helyben kifejtve, típuskövetkeztetéssel

    def name="World";
    System.Console.WriteLine($"Hello $name!");
    0
  }
}
